// K12.7  TimerAj[V
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class TimerAnimationM extends JPanel implements ActionListener {
    int number = -1;
    int cell = 20;
    int interval;
    boolean frozen = false;
    Image[] image;
    MediaTracker tracker;
    Timer timer;

    TimerAnimationM() {
        //C[W̃[h
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        tracker = new MediaTracker(this);
        image = new Image[cell];
        for (int i = 1; i <= cell; i++) {
           image[i-1] = 
              toolkit.getImage("rabbit/rabbit" + i + ".gif");
           tracker.addImage(image[i-1], 0);
        }
        //`̊Ԋu(~b)
        interval = 150;
        //^C}[̐ݒ
        timer = new Timer(interval, this);
        timer.setInitialDelay(0);
        timer.setCoalesce(true);
     
        addMouseListener(new MouseOpe());
        setBackground(Color.white);
        try{
           tracker.waitForAll();
	    }catch(InterruptedException e){ return; }

        //Aj[V̊Jn
        startAnimation();
    }

    public synchronized void startAnimation() {
       if (frozen) { 
            //Aj[V~߂̂,Ȃ
       } else {
           //Aj[VĊJ
           if (!timer.isRunning()) {
               timer.start();
           }
       }
    }

    public synchronized void stopAnimation() {
        if (timer.isRunning()) {//Aj[V~߂
            timer.stop();
        }
    }

    public void actionPerformed(ActionEvent e) {
        number++;  //ɕ\Zԍ
        repaint(); //`
    }

    public void paintComponent(Graphics g) {
       super.paintComponent(g); //wi̕`
       int x = getWidth()/2-30;
       int y = getHeight()/2-30;
       try {
           g.drawImage(image[number%cell], x, y, this);
       } catch (ArrayIndexOutOfBoundsException e) { return; }
                        //number-1̎ɕ`悪Ă΂ꂽ̗O
    }
   //}EXNbNŃAj[V~AĊJ
   class MouseOpe extends MouseAdapter{
      public void mousePressed(MouseEvent e) {
          if (frozen) {
               frozen = false;
               startAnimation();
           } else {
               frozen = true;
               stopAnimation();
           }
      }
   }  

   //EBhEN[YAACR̂߂̃EBhEXi[NX
   class WindowOpe extends WindowAdapter {
      public void windowClosing(WindowEvent e) {
         System.exit(0);
      }
      public void windowIconified(WindowEvent e) {
         stopAnimation();
      }
      public void windowDeiconified(WindowEvent e) {
         startAnimation();
      }
   }

    public static void main(String[] args) {
        JFrame f = new JFrame("Timer Animation");
        TimerAnimationM anime = new TimerAnimationM();
        f.addWindowListener(anime.new WindowOpe());
        f.getContentPane().add(anime, BorderLayout.CENTER);
        f.setSize(new Dimension(100, 100));
        f.setVisible(true);
    }
}
