// K15.2 `bgNCAg
import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ChatClient extends JFrame implements ActionListener{
    InputPanel inP;  //͈ƃ{^̃pl
    JTextArea talkArea;
    JMenuBar mbar;
    JMenu menu;
    JMenuItem saveM, exitM;

    Socket chatS = null;
    BufferedReader in = null;
    PrintStream out = null;

    String serverName;
    int port;
    String userName;

    public ChatClient(String title) {
       super(title);
       mbar = new JMenuBar();  //set menu
       setJMenuBar(mbar);
       menu = new JMenu("I");
       exitM = new JMenuItem("I");
       exitM.addActionListener(this);
       menu.add(exitM);
       mbar.add(menu);

       inP = new InputPanel();    
       talkArea = new JTextArea(20,40);
       talkArea.setEditable(false);
       JScrollPane scrollPane = new JScrollPane(talkArea);
       Container c = getContentPane();
       c.add(scrollPane, BorderLayout.CENTER);
       c.add(inP, BorderLayout.SOUTH);
    }

    public void actionPerformed(ActionEvent e){
       Object obj = e.getSource();
       if(obj == exitM){    System.exit(0);    }
    } 

    class InputPanel extends JPanel implements ActionListener{
       JTextField field;
       JButton goB;
   
       InputPanel(){
         setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
         field = new JTextField(40);
         goB = new JButton("");
         goB.addActionListener(this);
         add(field);
         add(goB);
       }
       public void actionPerformed(ActionEvent e) {
         sendMessage(field.getText());
         field.setText("");
         goB.requestFocus();
       }
    }

    public void startChat() {
        sendMessage(" ڑ܂B");
        String fromServer;
        try{
          while ((fromServer = in.readLine()) != null) {
            talkArea.append(fromServer + "\n");
          }
          out.close();
          in.close();
          chatS.close();
        }catch (IOException e){ 
          System.out.println("`bgɖ肪N܂B");
          System.exit(1);
        }
    }
 
    public void sendMessage(String msg) {
        String s = userName + ":" + msg;
        out.println(s);
    }

    //network setup
    public void initNet(String sName, int portN, String uName) {
        serverName = sName;
        port = portN;
        userName = uName;
        // create Socket
        try {
//          chatS = new Socket(serverName, port);
          chatS = new Socket(InetAddress.getLocalHost(), port);
          in = new BufferedReader(
                 new InputStreamReader(chatS.getInputStream()));
          out = new PrintStream(chatS.getOutputStream());
        } catch (UnknownHostException e) {
          System.out.println("zXgɐڑł܂B");
          System.exit(1);
        } catch (IOException e) {
          System.out.println("IORlNV𓾂܂B");
            System.exit(1);
        }

        startChat();
    }

    /**
     * java ChatClient T[oIPAhX |[gԍ [U
     * args[0] = serveraddress
     * args[1] = portnumber
     * args[2] = username
     */
    static public void main(String args[]) {
        if (args.length != 3 && args.length != 4) {
          System.out.println(
             "Usage: java ChatClient T[oIPAhX |[gԍ [U");
          System.out.println(": java ChatClient 210.0.0.1 2000 ariga");
          System.exit(0);
        }
        // Getting argument.
        String sName = args[0];
        int portN = Integer.valueOf(args[1]).intValue();
        String uName = args[2];
        System.out.println("serverName = " + sName);
        System.out.println("portNumber = " + portN);
        System.out.println("userName = " + uName);

        // Setup and start.
        ChatClient chat = new ChatClient(uName + " -> " + sName);
        chat.pack();
        chat.setVisible(true);
        chat.initNet(sName, portN, uName);
   System.out.println("setVisible ");
    }

}
